<template>
  <modal-component @click-backdrop="toggleMvModal(false)">
    <div class="modal-mv">
      <div class="top-arrow">
        <button @click="slideToDrawablePage">
          <img
            class="animated infinite fadeInDown delay-2s"
            src="../assets/img/scroll_down.png"
            alt="scroll down"
          />
        </button>
      </div>
      <div class="bottom-arrow">
        <button @click="openTemplePage">
          <img
            class="animated infinite fadeInDown delay-2s"
            src="../assets/img/scroll_down.png"
            alt="scroll down"
          />
        </button>
      </div>
      <img class="mv-kills-img" src="../assets/img/150k_kill.png" alt="150k kills" />
      <div class="youtube-wrapper">
        <div class="youtube-scaled-ratio">
          <youtube
            class="youtube"
            :video-id="videoId"
            :player-vars="{autoplay: 1}"
            player-width="100%"
          />
        </div>
      </div>
      <div class="mv-name">
        <span class="title">[Official MV] So Close</span>
        <span class="separator">-</span>
        <span class="singer">Binz x Phương Ly</span>
      </div>
      <button class="mv-share" @click="shareMvVideo">
        <font-awesome-icon icon="share-alt" />
        <span>Chia sẻ</span>
      </button>
      <button class="mv-back" @click="toggleMvModal(false)">&lt; Back</button>
    </div>
  </modal-component>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import VueYoutubeEmbed, {
  YouTubePlayer as Youtube,
  getIdFromURL
} from 'vue-youtube-embed';
import ModalComponent from './Modal.vue';
import { commonModule, Sharer, SlideName } from '../store/common/const';
import { YOUTUBE_MV_URL, SHARE_HASHTAG } from '../constants';
import { CommonService } from '../services';

Vue.use(VueYoutubeEmbed, { global: false });

@Component({
  components: { ModalComponent, Youtube }
})
export default class ModalMusicVideoComponent extends Vue {
  @commonModule.Action('toggleMvModal')
  toggleMvModal!: (isOpen: boolean) => void;
  @commonModule.Action('changeToSlide')
  changeToSlide!: (slide: SlideName) => void;
  @commonModule.Action('toggleTempleModal')
  toggleTempleModal!: (isOpen: boolean) => void;

  get videoId() {
    return getIdFromURL(YOUTUBE_MV_URL);
  }

  shareMvVideo() {
    CommonService.shareToFacebook(
      `http://www.facebook.com/sharer/sharer.php?u=${YOUTUBE_MV_URL}&hashtag=%23${SHARE_HASHTAG}`
    );
  }

  slideToDrawablePage() {
    this.toggleMvModal(false);
    this.changeToSlide(SlideName.DrawableImage);
  }

  openTemplePage() {
    this.toggleMvModal(false);
    this.toggleTempleModal(true);
  }
}
</script>

<style lang="scss" scoped>
.modal-mv {
  width: 90vw;
  margin: 0 auto;
  position: relative;
  top: -6vh;

  .top-arrow {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;

    button {
      display: inline-block;
      transform: rotate(180deg);
      -webkit-transform: rotate(180deg);
      -moz-transform: rotate(180deg);
      -o-transform: rotate(180deg);
    }

    img {
      height: 4vh;
    }
  }

  .bottom-arrow {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;

    img {
      height: 4vh;
    }
  }

  button {
    &:hover {
      cursor: pointer;
    }
  }

  .mv-kills-img {
    width: 70%;
    margin-bottom: 3vh;
  }

  .youtube-wrapper {
    background: url('../assets/img/scratch_area.png') no-repeat center center;
    background-size: 100% 100%;
    padding: 3vh;

    .youtube-scaled-ratio {
      position: relative;
      width: 100%;
      padding-bottom: 56.25%;

      .youtube {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;

        /deep/ iframe {
          width: 100%;
          height: 100%;
        }
      }
    }
  }

  .mv-name {
    font-family: $primary-font;
    color: white;
    font-weight: bold;
    font-style: italic;
    margin-top: 2vh;
    font-size: 2.2vh;

    span {
      display: block;
    }

    .title {
      color: $primary;
      text-transform: uppercase;
    }

    .separator {
      display: none;
    }
  }

  .mv-share {
    background-color: $primary;
    font-family: $primary-font;
    border: none;
    color: white;
    font-size: 2vh;
    margin: 3vh auto;
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    padding: 1.3vh 2vh;
    border-radius: 2vh;
    outline: none;

    svg {
      height: 3vh;
      margin-right: 1.5vh;
    }
  }

  .mv-back {
    background-color: transparent;
    border: none;
    color: white;
    font-family: $primary-font;
    font-size: 2vh;
    font-style: italic;
    outline: none;
  }
}

@include Orientation(Landscape) {
  .modal-mv {
    width: 60vw;
    max-width: 850px;
    top: -4vh;

    .mv-kills-img {
      width: 30%;
      margin-bottom: 3vh;
    }

    .youtube-wrapper {
      width: 50%;
      margin-left: auto;
      margin-right: auto;
      padding: 5vh;
    }

    .mv-name {
      span {
        display: inline;
      }

      .separator {
        display: inline;
      }
    }

    .mv-share {
      margin: 2vh auto;
    }
  }
}
</style>